using System;
using Eto.Drawing;
using Eto.Forms;
using UpToolLib.DataStructures;

namespace UpToolEto.Forms
{
    public class InitScreen : Form
    {
        private readonly Application _application;
        private readonly IExternalFunctionality _platform;
        private readonly Label _lab;
        public InitScreen(Application application, IExternalFunctionality platform)
        {
            _application = application;
            _platform = platform;
            Title = "UpTool2 Init";
            Resizable = false;
            Maximizable = false;
            Minimizable = false;
            WindowStyle = WindowStyle.None;
            _lab = new Label();
            Label header = new();
            header.Font = new Font(header.Font.Family, header.Font.Size * 2);
            header.Text = "UpTool2";
            Content = new StackLayout
            {
                Padding = 10,
                Items =
                {
                    new StackLayoutItem(header, HorizontalAlignment.Center),
                    new StackLayoutItem(_lab, HorizontalAlignment.Center)
                },
                VerticalContentAlignment = VerticalAlignment.Center
            };
            Shown += (_, _) => Size = new Size(700, 400);
        }

        public void SetText(string text)
        {
            _application.Invoke(() =>
            {
                _platform.Log(text);
                _lab.Text = text;
                _application.RunIteration();
            });
        }

        public override void Close() => _application.Invoke(() => base.Close());
    }
}