﻿using System;
using System.IO;
using System.Linq;

namespace UpToolLib.v1.Tool
{
    public class PathTool
    {
        public string Dir =>
            Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "UpTool2");

        public string TempPath => GetRelative("tmp");
        public string AppsPath => GetRelative("Apps");
        public string InfoXml => GetRelative("info.xml");

        public string GetRelative(params string[] segments) =>
            Path.Combine(new[] {Dir}.Concat(segments).ToArray());

        public string GetAppPath(Guid app) => Path.Combine(AppsPath, app.ToString());

        public string GetDataPath(Guid app) => Path.Combine(GetAppPath(app), "app");

        public string GetInfoPath(Guid app) => Path.Combine(GetAppPath(app), "info.xml");
    }
}