using System;
using System.Collections.Generic;
using UpToolLib.DataStructures;
using UpToolLib.v1.Tool;
using UpToolLib.v2;

namespace UpToolLib.v1
{
    public class UpToolLibV1
    {
        internal UpToolLibV1(IExternalFunctionality platform)
        {
            PathTool = new PathTool();
            XmlTool = new XmlTool(platform, PathTool);
            Installer = new AppInstall(platform, PathTool);
            AppExtras = new AppExtras(Installer, PathTool, Apps);
        }
        public readonly AppExtras AppExtras;
        public readonly AppInstall Installer;
        public readonly PathTool PathTool;
        public readonly XmlTool XmlTool;
        
        public readonly IDictionary<Guid, App> Apps = new Dictionary<Guid, App>();
        public static Version MinimumVer => Version.Parse("0.0.0.0");
    }
}