﻿using System;
using UpToolLib.DataStructures;
using UpToolLib.v1.Tool;

namespace UpToolLib.v2.TaskQueue
{
    public class InstallTask : KnownAppTask
    {
        private readonly AppInstall _installer;
        private readonly Action? _postInstall;

        internal InstallTask(IExternalFunctionality platform, AppInstall installer, App app, Action? postInstall) : base(platform)
        {
            App = app;
            _installer = installer;
            _postInstall = postInstall;
        }

        public override App App { get; }

        public override void Run()
        {
            bool trying = true;
            while (trying)
            {
#if !DEBUG
                try
                {
#endif
                    _installer.Install(App, true);
                    _postInstall?.Invoke();
                    trying = false;
#if !DEBUG
                }
                catch (Exception e1)
                {
                    trying = Platform.YesNoDialog("Install failed. Retry?\r\nException=" + e1, true);
                }
#endif
            }
        }
    }
}