﻿using UpToolLib.DataStructures;

namespace UpToolLib.v2.TaskQueue
{
    public abstract class KnownAppTask : AppTask
    {
        public abstract App App { get; }

        public override string ToString() => $"{TrimEnd(GetType().Name, "Task")} {App.Name}";

        private static string TrimEnd(string target, string trimString)
        {
            if (string.IsNullOrEmpty(trimString)) return target;

            string result = target;
            while (result.EndsWith(trimString)) result = result.Substring(0, result.Length - trimString.Length);

            return result;
        }

        protected KnownAppTask(IExternalFunctionality platform) : base(platform)
        {
        }
    }
}