﻿using System;
using UpToolLib.DataStructures;
using UpToolLib.v1.Tool;

namespace UpToolLib.v2.TaskQueue
{
    public class RemoveTask : KnownAppTask
    {
        private readonly AppExtras _extras;
        private readonly Action? _postInstall;

        internal RemoveTask(IExternalFunctionality platform, AppExtras extras, App app, Action? postInstall) : base(platform)
        {
            App = app;
            _extras = extras;
            _postInstall = postInstall;
        }

        public override App App { get; }

        public override void Run()
        {
#if !DEBUG
            try
            {
#endif
                _extras.Remove(App, true);
                _postInstall?.Invoke();
#if !DEBUG
            }
            catch (Exception e1)
            {
                Platform.OkDialog("Removal failed.\r\nException=" + e1);
            }
#endif
        }
    }
}