using System;
using System.Collections.Generic;
using UpToolLib.DataStructures;
using UpToolLib.v1.Tool;
using UpToolLib.v2.TaskQueue;

namespace UpToolLib.v2
{
    public class UpToolLibV2
    {
        internal UpToolLibV2(IExternalFunctionality platform, AppInstall install, AppExtras extras, PathTool pathTool, XmlTool xmlTool, IDictionary<Guid, App> apps)
        {
            AppFactory = new AppFactory(pathTool);
            UpdateChecker = new UpdateChecker(pathTool);
            TaskFactory = new TaskFactory(platform, install, extras, pathTool, AppFactory, apps);
            RepoManagement = new RepoManagement(platform, xmlTool, pathTool, AppFactory, apps);
        }

        public readonly UpdateChecker UpdateChecker;
        public readonly TaskFactory TaskFactory;
        public readonly AppFactory AppFactory;
        public readonly RepoManagement RepoManagement;
    }
}