using System;
using System.Xml.Linq;

namespace UpToolLib.v2
{
    public class UpdateCheck
    {
        public readonly Version OnlineVersion;
        public readonly Uri Installer;
        public readonly string InstallerHash;
        public readonly Uri App;
        public readonly string AppHash;

        public UpdateCheck(XElement meta)
        {
            OnlineVersion = Version.Parse(meta.Element("Version").Value);
            Installer = new Uri(meta.Element("Installer").Value);
            InstallerHash = meta.Element("InstallerHash").Value.ToUpper();
            App = new Uri(meta.Element("File").Value);
            AppHash = meta.Element("Hash").Value.ToUpper();
        }
    }
}